exercise_04_16: exercise_04_16.o | .gitignore
	g++ $^ -o $@ 

exercise_04_16.ii: exercise_04_16.cpp
	g++ -E $^ -o $@

exercise_04_16.s: exercise_04_16.ii
	g++ -S $^ -o $@

exercise_04_16.o: exercise_04_16.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04_16" > $@

removes:
	rm exercise_04_16.ii exercise_04_16.s exercise_04_16.o test.out exercise_04_16 .gitignore

test: exercise_04_16 
	./exercise_04_16 < test.in > test.out 
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED
